/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var gTempName;
var gUsesPopup;
var gStatusbar;

var pref = Components.classes["@mozilla.org/preferences-service;1"]
    .getService(Components.interfaces.nsIPrefBranch);
var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"]
    .getService(Components.interfaces.nsIRDFService);
var directory = rdf.GetResource("moz-abdirectory://")
    .QueryInterface(Components.interfaces.nsIAbDirectory);
var gDirectoryService = Components.classes['@mozilla.org/file/directory_service;1']
    .getService(Components.interfaces.nsIProperties);
var console = Components.classes["@mozilla.org/consoleservice;1"]
    .getService(Components.interfaces.nsIConsoleService);
var prompter = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
    .getService(Components.interfaces.nsIPromptService);


/*
 *  Read a mab file and return the data
 */
function readMabData(nsIMabFile, addLastMod)
{
  if (!nsIMabFile.exists()) return '';

  var fs = Components.classes['@mozilla.org/network/file-input-stream;1']
          .createInstance(Components.interfaces.nsIFileInputStream);
  var ss = Components.classes['@mozilla.org/scriptableinputstream;1']
          .createInstance(Components.interfaces.nsIScriptableInputStream);
  var str='';
  try{
    fs.init(nsIMabFile, 0x01, 0000, false);
    ss.init(fs);
    str = ss.read(-1);
    ss.close();
    fs.close();
  } catch(e){ alert('Read file:\n'+e); }
//    return str;
  if (addLastMod) {
    var lmt=new Date(nsIMabFile.lastModifiedTime);
    return str.replace(/-->[^\r\n]*/,'--> '+lmt);//append to the // <!-- <mdb:mork:z v="1.4"/> -->
  } else
    return str;
}

/*
 *  Save Data to a mab File
 */
function writeMabData(nsIMabFile, abData)
{
  try {
    //if (nsIMabFile.exists() && nsIMabFile.isFile()) nsIMabFile.remove(false);
    var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
      createInstance(Components.interfaces.nsIFileOutputStream);
    strm.QueryInterface(Components.interfaces.nsIOutputStream);
    strm.QueryInterface(Components.interfaces.nsISeekableStream);
    strm.init( nsIMabFile, 0x20|0x02|0x08, 0600, 0 );
      // 0x02=PR_WRONLY, 0x08=PR_CREATE_FILE, 0x20=PR_TRUNCATE
    strm.write( abData, abData.length );
    strm.flush();
    strm.close();
  } catch(e) { alert('File write error of '+nsIMabFile.target+':\n'+e); return null;}
  return nsIMabFile;
}

/*
 *  copy a mab file to another location
 */
function saveMabFile(mabName, mabFile, directory, filename)
{
    var localMabFile = getDir('ProfD');
    localMabFile.appendRelativePath( mabFile );

    try {
      var file = Components.classes["@mozilla.org/file/local;1"].
        createInstance(Components.interfaces.nsILocalFile);
      file.initWithFile( directory );
      file.appendRelativePath( filename );
//TODO: eventuell umbenennen statt lschen
      if (file.exists() && file.isFile()) { file.remove(false); }
      localMabFile.copyTo( directory, filename );
        //creates directory, if not existing! retains lastModifiedTime !
    } catch(e) { return false; }
    return true;
} //


function replaceAddressBook(mabName, mabFile, file) {
if (!mabFile) {
 var err='Internal error: empty filename for addressbook "'+mabName+'"';
 alert(err);
 return err;
}
  var dir=gAddressbooksSync.getAddressBook(mabName);
dump('have a '+dir+'\n');
  var ret;
  var syncpolicy = gAddressbooksSync.syncpolicy;
  if (syncpolicy=='entry') {
    //workaround for a very mysterious problem:
    // Maillists are not loaded if filename contains spaces!
    if (file.path.indexOf(' ')>=0) {
      var newFile=getDir('TmpD');
      gTempName='abstemp.mab';
      newFile.appendRelativePath(gTempName);
      if (newFile.exists() && newFile.isFile()) { newFile.remove(false); }
      file.copyTo( getDir('TmpD'), gTempName );
      file=newFile;
    }
    ret=replaceAddressBook_viaEntry(mabName, mabFile, file);
  } else {
    var uri=dir.directoryProperties.URI;
    if (uri==kPersonalAddressbookURI || uri==kCollectedAddressbookURI) {
      ret=replaceAddressBook_viaEntry(mabName, mabFile, file);
    } else {
      ret=replaceAddressBook_viaFile(mabName, mabFile, file);
    }
  }
  dir.lastModifiedDate=gAddressbooksSync.appstarttime; //set to 'not modified'
  return ret;
}

function replaceAddressBook_viaFile(mabName, mabFile, file)
{
  gAddressbooksSync.deleteAddressBook( mabName, mabFile ); // NOP for 'history' und 'pab'!
  statustxt('.',0, false);
  var nsIMabFile = getDir('ProfD');
  var path=nsIMabFile.path;
  nsIMabFile.appendRelativePath( mabFile );
  if (nsIMabFile.path==path) {
   var err='Internal error: error creating path to addressbook "'+mabName+'" with filename "'+mabFile+'"';
   alert(err);
   return err;
  }
  if (nsIMabFile.exists() && nsIMabFile.isFile()) { nsIMabFile.remove(false); }
  file.copyTo( getDir('ProfD'), mabFile );
  statustxt('.',0, false);

  gAddressbooksSync.createAddressBook( mabName, mabFile );
  return '';
}

/*
 * replace content of an address book with given data
 */
function replaceAddressBook_viaEntry(mabName, mabFile, file)
{
  var dir=gAddressbooksSync.getAddressBook(mabFile);  //dir=nsIAbDirectory
dump('have a '+dir+'\n');

  if (!dir) return 'failed to create addressbook';

  //
  // clear target addressbook
  //
  try  {
    var cardsE=dir.childCards;
    var cards = Components.classes["@mozilla.org/supports-array;1"].
      getService(Components.interfaces.nsISupportsArray);
      //convert nsIEnumerator to nsISupportsArray (don't try dir.dropCard()!)
    var goon=1;
      // Loop over the cards
    try { cardsE.first() } catch (e) { goon=0; }
    while (goon) {
      var card = cardsE.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
      cards.AppendElement(card);
      try { cardsE.next() } catch(e) { goon=0; }
    }
    dir.deleteCards(cards);  // delete the cards from the to-be synced addressbook

    var lists=dir.childNodes;  //delete lists
    while( lists.hasMoreElements() ) {
      var list = lists.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
      dir.deleteDirectory(list);
    }
  } catch(e) { alert('clear addressbook: '+e); }

// The cards are not deleted immediately, they are put on a deletedCards Table
// This table can't be purge programmatically, they are automatically purged
// iff more than 50 Cards are in the table and only cards are purged that are
// older than 6 month :-(((
// Therefore I set the LastModifiedDate attribute on the deleted cards to an
// appropriate date (1.1.2000) so they will be deleted later on
  var ab = Components.classes["@mozilla.org/addressbook;1"].
    getService(Components.interfaces.nsIAddressBook);
  var curDB=ab.getAbDatabaseFromURI(dir.directoryProperties.URI);

  try  {
    var count=new Object();
    var dListObj=new Object();
    curDB.getDeletedCardList(count, dListObj);
    if (count.value) {
      var dList=dListObj.value;
      for (var i=0; i<dList.Count(); i++)
      {
        var card = dList.GetElementAt(i).QueryInterface(Components.interfaces.nsIAbCard);
//        386d3570 = 946681200 = 1.Jan.2000, must not be 0!!
        curDB.setCardValue(card, 'LastModifiedDate', '386d3570' , false);
//wow, with this function, i can set my own values!!
      }
    }
  } catch(e) { alert('reset modDate: '+e); }
  curDB.close(true);

  // open the addressbook database file
  var db=Components.classes["@mozilla.org/addressbook/carddatabase;1"].
    getService(Components.interfaces.nsIAddrDatabase);
  var tdb=db.open(file, true, false);
  tdb.QueryInterface(Components.interfaces.nsIAddrDatabase);
  //tdb.dbPath is undefined
  // give me the maillists
    // must be moz-abmdbdirectory, not moz-abdirectory
  var temp=Components.classes['@mozilla.org/rdf/resource-factory;1?name=moz-abmdbdirectory']
      .createInstance(Components.interfaces.nsIAbDirectory);
  tdb.getMailingListsFromDB(temp);

  var tCards=tdb.enumerateCards(temp);

  // create maillists
  try  {
    var tMailLists=temp.childNodes;
    while (tMailLists.hasMoreElements()) {
      var tMailList=tMailLists.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
      var nMailList = Components.classes["@mozilla.org/addressbook/directoryproperty;1"].
        createInstance().QueryInterface(Components.interfaces.nsIAbDirectory);
      nMailList.dirName = tMailList.dirName;
      nMailList.listNickName = tMailList.listNickName;
      nMailList.description = tMailList.description;
      dir.addMailList(nMailList);
    }
  }catch(e) { alert('create maillists: '+e); }

  //
  // copy cards from database to mab
  //
// - Thunderbird has no way to copy a maillist! If you drag and drop a maillist
//   inside the addressbook manager the maillist becomes a normal card!!
// - The dirName Property of maillists is unique! Thunderbird refuses to create
//   a maillist with the same name (applies only in the GUI)
// - => How to:
//   create maillists
//   loop over old cards
//     copy card
//     find all maillists, the card is in
//       find the corresponding new maillist
//       insert the copy of the card into these maillists

  try {
    var goon=1;
      // Loop over the cards
    try { tCards.first() } catch (e) { goon=0; }
    while (goon) {
      // need two references to the current card. One for a later use with .equals
      // the other gets modified to be the copied card
      var tCard = tCards.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
      var nCard = tCards.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
if (tCard.isAnEmailAddress || tCard.isASpecialGroup || !tCard.isANormalCard)
alert('unnormal card: '+tCard.displayName+'('+tCard.primaryEmail+') isAnEmailAddress='+tCard.isAnEmailAddress
+' isANormalCard='+tCard.isANormalCard+' isASpecialGroup='+tCard.isASpecialGroup);
            //tCard.isANormalCard is also true for maillist!
      if (!tCard.isMailList) { // only non-maillists
//        var nCard=dir.addCard(tCard);  // add card, afterwards: nCard.equals(tCard) is true !!
        dir.dropCard(nCard, false);  // changes nCard to be the new card!
        //find maillists, the card is in
        var tMailLists=temp.childNodes; //mailLists=nsISimpleEnumerator, Get the children directories
        while (tMailLists.hasMoreElements()) {
          var tMailList=tMailLists.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
          // loop over cards in maillist
          for (var i=0; i<tMailList.addressLists.Count(); i++)
          {
            var tmlCard = tMailList.addressLists.GetElementAt(i).QueryInterface(Components.interfaces.nsIAbCard);
            if (tCard.equals(tmlCard)) {
              // find new maillist and insert new card
              var nMailLists=dir.childNodes; //mailLists=nsISimpleEnumerator, Get the children directories
              while (nMailLists.hasMoreElements()) {
                var nMailList=nMailLists.getNext().QueryInterface(Components.interfaces.nsIAbDirectory);
                if( tMailList.dirName == nMailList.dirName) {  // got it!
                  nMailList.dropCard(nCard, false);  // insert new card to new maillist
                  break;
                }
              }
              break;
            }
          }
        }
      }
      try { tCards.next() } catch(e) { goon=0; }
    }
  } catch(e) { alert(e); }

  tdb.forceClosed();  //!!!

  return '';
}

function getLastModified(dir) {  //dir=nsIAbDirectory
  if (!dir) return 0;

  var lastModifiedDate=dir.lastModifiedDate;  //set via abs_gAbSessionListener
dump('abs: last modified date of dir '+dir.dirName+': '+lastModifiedDate+'\n');
  var count=0;
  var email='';
  try  {
    var cardsE=dir.childCards;
    var cards = Components.classes["@mozilla.org/supports-array;1"].
      getService(Components.interfaces.nsISupportsArray);
      //convert nsIEnumerator to nsISupportsArray (don't try dir.dropCard()!)
    var goon=1;
      // Loop over the cards
    try { cardsE.first() } catch (e) { goon=0; }
    while (goon) {
      var card = cardsE.currentItem().QueryInterface(Components.interfaces.nsIAbCard);
      var lmt=card.lastModifiedDate;
      if (lmt>lastModifiedDate) {
        lastModifiedDate=lmt;
        email=card.primaryEmail;
      }
      count++;
      try { cardsE.next() } catch(e) { goon=0; }
    }
  } catch(e) { alert(e); }
if (email) dump('abs: last modified date of email '+email+': '+lastModifiedDate+'\n');
  return lastModifiedDate;
}

/*
 * return URI for remote syncronization
 */
function getSyncURI(masked)
{
  var syncpassword='';
  var syncprotocol = gAddressbooksSync.protocol;
  var synchost = gAddressbooksSync.host;
  var syncuser = gAddressbooksSync.user;
  var syncpath = gAddressbooksSync.path;

  var syncpassword='';
  if (masked) {
    syncpassword='**********';
  } else
    try{ syncpassword = get_password(synchost, syncuser); } catch(e) {}

  if( ! synchost )
    return "";
  var userpass=encodeURIComponent(syncuser) +(syncpassword?":":"")+encodeURIComponent(syncpassword);
  if(userpass)
    userpass += "@";
  var uri=syncprotocol + "://" + userpass + synchost + syncpath+'/';

  return uri;
}

/*
 *  get a special Directory, 'ProfD' or 'TmpD'
 */
function getDir(special) {
/*
  var profileFolder = directoryService.get(special,  Components.interfaces.nsIFile);
  var profileDir = profileFolder.QueryInterface(Components.interfaces.nsILocalFile);
  var nsIMabFile = profileDir.clone().QueryInterface(Components.interfaces.nsILocalFile);
*/
  var dir = gDirectoryService.get(special,  Components.interfaces.nsIFile)
    .QueryInterface(Components.interfaces.nsILocalFile);
//  return dir.clone().QueryInterface(Components.interfaces.nsILocalFile);
  return dir;
}

function deleteTempFile(filename) {
  var nsITmpFile=getDir('TmpD');
  nsITmpFile.appendRelativePath(filename);
  if (!nsITmpFile.exists() || !nsITmpFile.isFile()) return true;
  var deleted=false;
  try { nsITmpFile.remove(false) }
  catch(e) {
    switch (e.result) {
      case Components.results.NS_ERROR_FILE_ACCESS_DENIED:
    //  after call to replaceAddressBook, an immediate remove
    //  throws an 'access denied'
//        setTimeout(deleteTempFile, 1000, filename, count);
        break;
      case Components.results.NS_ERROR_FILE_NOT_FOUND:
        deleted=true;
        break;
      default:
        alert(e.message);
        deleted=true; // not really
        break;
    }
    return deleted;
  }
  return true;
}

function getTimeStamp()
{
    var date = new Date();
    return Math.floor( date.getTime() / 1000 );

} // getTimeStamp

function timeString(time) { //time in seconds
  var d=time?new Date(time):new Date();;
  //var s=d.toLocaleString();
  s=d.toLocaleFormat('%d.%b.%Y %H:%M:%S');
  return s;
}

function errorstr(aError)
{
  var error;

  var intErr=0;
  if (typeof aError == 'string') {
    var err=Number(aError);
    if (!isNaN(err)) aError=err;
  }
  //Errorcodes:
  //    xpcom/base/nsError.h
  //    netwerk/base/public/nsNetError.h
  switch(aError){
  // internal errors
    case -1:
      intErr=1;
      error=strings.getString('unexperr'); // 'unexpected initialization error';
      break;
    case -2:
      intErr=2;
      error=strings.getString('localreaderr'); // 'local mab file read error';  //access denied (also gives unhandled exception), does not exist
      break;
    case -3:
      intErr=3;
      error=strings.getString('illimap');
      break;
  //Thunderbird network error, see netwerk/base/public/nsNetError.h
    case 0x804b000d:
      //NS_ERROR_CONNECTION_REFUSED 13
      //The connection attempt failed, for example, because no server was listening
      //at specified host:port.
      intErr=4;
      error=strings.getString('protnotavail'); // 'protocol not available';
      break;
    case 0x804b000e:
        //NS_ERROR_NET_TIMEOUT 14
        //The connection was lost due to a timeout error.
      intErr=12;
      error=strings.getString('timeout'); // 'timeout';
      break;
    case 0x804b0011:
      //NS_ERROR_NO_CONTENT 17
      intErr=16;
      error='No content';
        // used, when Firefox is set as 'network.protocol-handler.app.ftp'
        // for FTP. The addressbook is shown in Firefox!
      break;
    case 0x804b0012:
      //NS_ERROR_UNKNOWN_PROTOCOL 18
      // The URI scheme corresponds to an unknown protocol handler.
      intErr=17;
      error='Unknown protocol handler';
      // happens after removing application-handler after NS_ERROR_NO_CONTENT
      break;
    case 0x804b0015:
      //NS_ERROR_FTP_LOGIN 21
      intErr=10;
      error=strings.getString('illcred'); // illegal credentials';
      break;
    case 0x804b0016:
      //NS_ERROR_FTP_CWD 22
      intErr=15;
      error=strings.getString('nofile');
      break;
//NS_ERROR_FTP_PASV 23
//NS_ERROR_FTP_PWD 24
//NS_ERROR_FTP_LIST 25
    case 0x804b001e:
      //NS_ERROR_UNKNOWN_HOST 30
      intErr=5;
      error=strings.getString('hostnotfound'); // 'host not found';
      break;
    case 0x804b002a:
      //NS_ERROR_UNKNOWN_PROXY_HOST 42
      intErr=13;
      error=strings.getString('proxynotfound'); // 'proxy not found';
      break;
    case 0x804b0048:
      //NS_ERROR_PROXY_CONNECTION_REFUSED 72
      intErr=14;
      error=strings.getString('proxyerr'); // 'proxy error';
      break;
  //external errors (server error, windows error)
    case 0x80004002:
      /* NS_ERROR_NO_INTERFACE: Returned when a given interface is not supported. */
      intErr=18;
      error='External application handler set';
        //This happens on ftp upload when an external handler is set
      break;
    case 0x80004005:
      /* NS_ERROR_FAILURE: Returned when a function fails */
      intErr=6;
      error=strings.getString('permdenied'); // frher 'fileunavail', file unavailable
        //??? (with FTP: Error 550: File unavailable (e.g., file not found, no access).
        //(with IMAP: wenn der alte Upload mit 'CopyFileMessage' verwendet wird)
      break;
    case 405:
      intErr=7;
      error=strings.getString('methodnotallowed'); // method not allowed';  //method is something like PUT,POST or GET
      break;
    case 404:
      intErr=8;
      error=strings.getString('notfound'); // not found';
      break;
    case 403:
      intErr=9;
      error=strings.getString('permdenied'); // permission denied';
      break;
    case 401:
      intErr=11;
      error=strings.getString('illcred'); // illegal credentials';
      break;
    case 0:
    case 201:
    case 204:
      error=strings.getString('ok');
      break;
    default:
      var sError;
      if (aError&0xffff0000) {
        if ((aError>>>16)==0x804b)  //TB Netzwerk errors, see netwerk/base/public/nsNetError.h
          sError='TB-'+(aError&0xffff).toString(10);
        else
          sError='0x'+aError.toString(16);
      } else
        sError=aError;
      error='Error '+sError;
      break;
  }
//  throws 'no memory' exception
//  var errorService = Components.classes["@mozilla.org/xpcom/error-service;1"].
//            getService(Components.interfaces.nsIErrorService);
//  error+=' ('+errorService.getErrorStringBundleKey(aError)+')';
  if (intErr) error+=' ('+intErr+')';
  return error;
}

var line;
var lastnewline;
function statustxt(aStatus, newline, doalert, longText, addText)
  //newline: 1: start a new line, 2: end a line, 3:both, 0: append to line
  //          -1: Start of new sequence, -2 End of sequence
{
  if (doalert) gLifeTime=5; //show window a little bit longer
                            //this should really be done somehwere else ;-)

  if (newline==-2 && lastnewline==-2) return;

  var now; var appStart;
  if (newline==-1) {
    now = timeString();
    appStart = timeString(gAddressbooksSync.appstarttime*1000);
    appStart = 'Thunderbird start '+appStart;
    gAddressbooksSync.statusText=null;
    gAddressbooksSync.statusText=now+'\n';
    gAddressbooksSync.statusText=appStart+'\n';
  }
  gAddressbooksSync.statusText=longText?longText:aStatus;
  if (addText) gAddressbooksSync.statusText=' ('+addText+') ';
  if (newline&2 || newline<0) gAddressbooksSync.statusText="\n";

  // popup menu
  if (gUsesPopup) {
    var status=document.getElementById("status");
    if (status) {
      if (newline==-1) status.value=(longText?longText:aStatus)+'\n';
      else if (newline==-2) status.value+=(longText?longText:aStatus)+'\n';
      else if (newline>=0) {
        status.value+=(longText?longText:aStatus);
        if (newline&2) status.value += "\n";
        status.inputField.scrollTop=status.inputField.scrollHeight;
      }
    }
  }

  //status bar
  if (!gStatusbar) {
    var w=window;
    try { // will fail on onUnload
      while (w && w.location!='chrome://messenger/content/messenger.xul') w=w.opener;
    } catch(e) { w=null; }
//  var maindoc = window.location!=?window.opener.document:document;
//alert(maindoc.location);
//  if (maindoc && maindoc.location=='chrome://messenger/content/options.xul') maindoc=maindoc.opener.document;
    if (w)
      gStatusbar=w.document.getElementById("statusText");
  }
  if (gStatusbar) {  //at onUnload gibts das nicht mehr!
    if (newline==-1) gStatusbar.label=aStatus+'  ';
    if (newline==-2) gStatusbar.label+='  '+aStatus;
    if (newline>=0) {
      gStatusbar.label+=aStatus;
      if (newline&2) gStatusbar.label+='  ';
    }
  }

  aStatus=longText?longText:aStatus;
  if (addText) aStatus+=' ('+addText+') ';

  //error console
  if (newline==-2)
    console.logStringMessage('AddressbooksSynchronizer: '+gAddressbooksSync.statusText);

//////////////
  if (gAddressbooksSync.exiting) {
    var fline='';
    var flags=0x10|0x08|0x02;
          // 0x02=PR_WRONLY, 0x10=PR_APPEND, 0x08=PR_CREATE_FILE
    if (newline==-1) {
      fline='----'+now+'\n'+appStart+'\n'+aStatus+'\n';
      flags=0x08|0x02;
    } else if (newline==-2) fline+=aStatus+'\n';
    else {
      fline=aStatus;
      if (newline&2) fline+="\n";
    }
    if (fline) {
      try {
        var logFile = getDir('TmpD');
        logFile.appendRelativePath( 'AddressbookSynchronizer.log' );
        var strm = Components.classes["@mozilla.org/network/file-output-stream;1"].
          createInstance(Components.interfaces.nsIFileOutputStream);
        strm.QueryInterface(Components.interfaces.nsIOutputStream);
        strm.QueryInterface(Components.interfaces.nsISeekableStream);
        strm.init( logFile, flags, 0600, 0 );
        strm.write( fline, fline.length );
        strm.flush();
        strm.close();
      } catch(e) { console.logStringMessage('AddressbooksSynchronizer: '+'File write:\n'+e+'\n'); }
    }
  }
////////////

  lastnewline=newline;
  if (doalert)
    alert(gAddressbooksSync.statusText);
}

function addMenu()
{
  try{
    var menu=document.getElementById("tasksMenu");
    var popup=menu.firstChild;
    var sep=document.getElementById("prefSep");
    var strings = document.getElementById("strings");
    var label=strings.getString('menuname'); //"Addressbooks Synchronizer";
    var accesskey=strings.getString('menushortcut');
  }catch(e){alert(e); return;}

  var  element = document.createElementNS("http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul", "menuitem");
  element.setAttribute("id", "gg-addressbookSync");
  element.setAttribute("label", label);
  element.setAttribute("accesskey", accesskey);
  element.setAttribute("oncommand", "showOptions();");
  popup.insertBefore(element,sep);
}

//There is a problem, when deleting and recreating existing addressbooks
//(syncpolicy=='file'):
//If the addressbook window is open, tb may crash afterwards if accessing
//the recreated addressbook in the addressbook window.
//therefore we close the addressbook or select the first addressbook in the window
//and delay the delete/create process
//But nothing really helped :-(
function secureAddressbook() {

  var count=0;
  var windowsEnum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                   .QueryInterface(Components.interfaces.nsIWindowMediator)
                   .getEnumerator("mail:addressbook");
  while (windowsEnum.hasMoreElements()) {
    var w=windowsEnum.getNext();
//    w.close();
    var abTree=w.document.getElementById("dirTree");
    if (abTree) {
      if (abTree.view.selection.currentIndex!=0) {
        w.SelectFirstAddressBook();
        if (w.GetSelectedDirectory()!=kPersonalAddressbookURI) {
          alert('Not personal addressbook - please inform the Author (G.Gersdorf@ggbs.de)');
        }
        count++;
      }
    } else {
//alert('no abTree :-((');
    }
  }
  return count;
}

function showOptions()
{
  var windowsEnum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                   .QueryInterface(Components.interfaces.nsIWindowMediator)
                   .getEnumerator("addressbookssync-options");
  var options=windowsEnum.getNext();
  if (options)
    options.focus();
  else
    window.open("chrome://addressbookssync/content/options.xul","_blank","chrome,resizable,titlebar=yes");
}

/*
 *  This is, where every up-/download starts!
 */
function showPopup(direction, singlebook, usepopup, automatic, force)
{
  //singlebook: a mabFile or null
  //usepopup: if true, use popups, else ask property 'hidepopups'
  //automatic: true, if its an automatic down-/upload and programmstart/-end
  //force: if true, upload mabs, even if not changed
  if (direction=='upload' && gAddressbooksSync.noupload) return;

  if (!singlebook && gAddressbooksSync.syncedAddressbooks((direction=='download')?'down':'up','').Count()==0)
    return;  //nothing to do

//TODO: possible race condition!
  if (gAddressbooksSync.state!='') {  // we are already doing an up-/download
    if (!automatic) {
      var strings = document.getElementById("strings");
      alert(strings.getString('inprogress'));
    }
    return;
  }

  // see comment with secureAddressbook()
  if (direction=='download' && secureAddressbook()) {
    setTimeout(showPopup, 1000, direction, singlebook, usepopup, automatic, force);
    return;
  }

  gUsesPopup=usepopup || !gAddressbooksSync.hideallpopups;
//  if (!usepopup) hidepopups = gAddressbooksSync.hidepopups;

  gAddressbooksSync.state=direction;
dump('direction is '+direction+', state now '+gAddressbooksSync.state+'\n');

  if (!gUsesPopup) {
    if (direction=='download') download(singlebook, force);    //in download.js
    else                       upload(singlebook, force);      //in upload.js
  } else {
    var x=Math.floor(window.outerWidth/2+window.screenX);
    var y=Math.floor(window.outerHeight/2+window.screenY);
    var w=window.openDialog("chrome://addressbookssync/content/"+direction+".xul","_blank",
      'chrome,resizable,titlebar=no', singlebook, force);
//if adding more arguments: update in call to upload() and download() above
//    AND in upload.xul and download.xul!!
  }
}

function checkOffline(direction) {
  if (ioService.offline) {
    var windowsEnum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                     .QueryInterface(Components.interfaces.nsIWindowMediator)
                     .getEnumerator("mail:3pane");  //.getMostRecentWindow("mail:3pane")
    var w=windowsEnum.getNext();  // there must be one (the current)! (really? what if tb killed)
    if (!w) {
      gAbort=2;
      killMe();
      return false;
    }
    var goOnline = direction=='upload' ?
        w.PromptSendMessagesOffline() : w.PromptGetMessagesOffline();
    if(goOnline==0) {
      if (!w.gOfflineManager)
        w.GetOfflineMgrService();
      w.gOfflineManager.goOnline(false /* sendUnsentMessages */,
                             false /* playbackOfflineImapOperations */,
                             w.msgWindow);
    } else {
      gAbort=2;
      killMe();
      return false;
    }
  }
  return true;
}

function killMe()
{
  //gAbort=0: normales ende
  //gAbort=1: aborted
  //gAbort=2: killed
//alert('killMe '+gAbort);
  if (gAbort<2 && cleanUp) {
    cleanUp();
    cleanUp=null;
  }
  if (gTempName && !gAbort) {
    if (!deleteTempFile(gTempName)) {
      setTimeout(killMe,1000);
      return;
    } else {
      gTempName='';
    }
  }

  if (gAbort==1)
    // this does not fire on unexpected errors, since
    // killMe is probably not called from processing loop
    statustxt(strings.getString('aborted'), -2, false);
  else if (gAddressbooksSync.state) //kommt sonst bei imap 2x (??)
    statustxt(strings.getString('ok'), -2, false);

//  if(gLifeTime>0 && gUsesPopup && gAbort<2) {
  if(gLifeTime>0 && gAbort<2) {
    setTimeout(killMe,gLifeTime*1000);
    gLifeTime=0;
    return;
  }

/* lschen der Statuszeile eventuell timer gesteuert! */
  if (gStatusbar) {  //at onUnload gibts das nicht mehr!
    gStatusbar.label='';
  }

  gAddressbooksSync.state=''; //Up-/Download ready
  if (gAddressbooksSync.pendingupload) {
//    gAddressbooksSync.pendingupload=false;
    showPopup('upload', false, false, true, false);
  }

//    alert(gAddressbooksSync.statusText);
//if (gAbort==2)  //test
  if (gUsesPopup) setTimeout(close,0);
}


function addListener() {
  var addrbookSession = Components.classes["@mozilla.org/addressbook/services/session;1"]
      .getService().QueryInterface(Components.interfaces.nsIAddrBookSession);
  addrbookSession.addAddressBookListener(
    abs_gAbSessionListener, -1);
//    Components.interfaces.nsIAddrBookSession.directoryRemoved |
//   Components.interfaces.nsIAddrBookSession.changed);
}
function removeListener() {
  var addrbookSession = Components.classes["@mozilla.org/addressbook/services/session;1"]
      .getService().QueryInterface(Components.interfaces.nsIAddrBookSession);
  addrbookSession.removeAddressBookListener(abs_gAbSessionListener);
}
var abs_gAbSessionListener = {
  onItemAdded: function(parentDir, item) {
    var dir=parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
    try {
      var card=item.QueryInterface(Components.interfaces.nsIAbCard);
dump('abs: item added parent='+dir.dirName+' email='+card.primaryEmail+'\n');
      dir.lastModifiedDate=Math.round(Date.now()/1000);
      card.setCardValue('LastModifiedDate',dir.lastModifiedDate);
    } catch(e) {}
  },
  onItemRemoved: function(parentDir, item) {
    var dir=parentDir.QueryInterface(Components.interfaces.nsIAbDirectory);
dump('abs: something removed parent='+dir.dirName+'\n');
    try {
      var card=item.QueryInterface(Components.interfaces.nsIAbCard);
dump('abs: item removed parent='+dir.dirName+' email='+card.primaryEmail+'\n');
    } catch(e) {}
    dir.lastModifiedDate=Math.round(Date.now()/1000);
  },
  onItemPropertyChanged: function(item, property, oldValue, newValue) {
    //property, oldValue and newValue are always null
    var card=item.QueryInterface(Components.interfaces.nsIAbCard);
dump('item changed '+card.primaryEmail+' '+property+': '+oldValue+'->'+newValue+'\n');
    // this also sets the lastModifiedDate on the card
  }
};

function disableUpload() {
  //Toolbar button in 3Pane window and(!) addressbook window
  var id=document.getElementById('AddressbooksUploadIcon');
  if (id) id.style.display='none';
  //Context menuitem in addressbook
  id=document.getElementById('absContextUpload');
  if (id) id.style.display='none';
  //Menuitems in addressbook
  id=document.getElementById('absTaskUploads');
  if (id) id.style.display='none';
  id=document.getElementById('absTaskUpload');
  if (id) id.style.display='none';
  //Upload now button in Options
  id=document.getElementById('autouploadnow');
  if (id) id.style.display='none';
  //checkbox 'Automatic upload'
  id=document.getElementById('autoupload');
  if (id) id.style.display='none';
  //checkbox 'Timed upload'
  id=document.getElementById('timedupload');
  if (id) id.style.display='none';
  //export
  id=document.getElementById('export');
  if (id) id.style.display='none';
  //checkbox for seperate Up-/download disablen
  id=document.getElementById('separateupdown');
  if (id) id.style.display='none';
  //Strategy for IMAP Upload disablen
  id=document.getElementById('imappolicy');
  if (id) id.style.display='none';
  //...
}

function askOverwrite(cur, alwaysask) {
  var dummy=new Object;
statustxt('Calling askOverwrite??', 3, 0, '', '');
dump('Calling askOverwrite??\n');
  if (alwaysask) {
    return prompter.confirmEx(window, 'Load '+cur.directoryProperties.description,
        strings.getString('mab')+' "'+cur.directoryProperties.description+'":\n'+strings.getString('askoverwrite'),
//          (BUTTON_POS_0) * (BUTTON_TITLE_YES) + (BUTTON_POS_1) * (BUTTON_TITLE_NO) + BUTTON_POS_0_DEFAULT
            (1)            * (3)                + (256)          * (4)               + 0,
            null, null, null, null, dummy
        )
  }
  if (gAddressbooksSync.appstarttime<getLastModified(cur) &&
      (gAddressbooksSync.downloadpolicy=='keep' ||
            gAddressbooksSync.downloadpolicy=='ask' &&
            prompter.confirmEx(window, 'Download '+cur.directoryProperties.description,
                strings.getString('mab')+' "'+cur.directoryProperties.description+'":\n'+strings.getString('askmodified'),
//                  (BUTTON_POS_0) * (BUTTON_TITLE_YES) + (BUTTON_POS_1) * (BUTTON_TITLE_NO) + BUTTON_POS_0_DEFAULT
                    (1)            * (3)                + (256)          * (4)               + 0,
                    null, null, null, null, dummy
                )
          )) {
    return false; //skip
  } else
    return true;  //overwrite
}
