/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is AddressbooksSynchronizer.
 *
 * The Initial Developer of the Original Code is Gnter Gersdorf.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *  Gnter Gersdorf <G.Gersdorf@ggbs.de>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var pref = Components.classes["@mozilla.org/preferences-service;1"].
             getService(Components.interfaces.nsIPrefBranch);

var gAddressbooksSync = Components.classes["@ggbs.de/addressbooksSync;1"].
      getService(Components.interfaces.AddressbooksSync);

function onLoad()
{
  gAddressbooksSync.appstarttime=0; // the argument is ignored
dump('in onLoad '+window.location+' appstart='+gAddressbooksSync.appstarttime+' state='+gAddressbooksSync.state+'\n');

  if (window.location=='chrome://messenger/content/messenger.xul') {
    var windowsEnum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                     .QueryInterface(Components.interfaces.nsIWindowMediator)
                     .getEnumerator("mail:3pane");
    var w=windowsEnum.getNext();  // there must be one (the current)!
    if (!windowsEnum.hasMoreElements()) { //no more windows, this is the first! Sync!

//alert('onLoad first:'+window.location+"\n");
      if (gAddressbooksSync.autodownload) {
          //without the delay of some (one) seconds and we are using a master
          //password, the window to enter the masterpassword popups twice!
        var delay = gAddressbooksSync.delayautodownload;
        setTimeout(showPopup, delay*1000, 'download', null, false, true, false);
      }
      addMenu();  // add addressbookssync to tools-menu
      addListener();  // add a listener to be informed about changes in addressbooks

      // start timer if necessary
      gAddressbooksSync.loadtimer=gAddressbooksSync.loadtimer;
    }
//else alert('onLoad NOT first:'+window.location+"\n");
  }
  if (gAddressbooksSync.noupload) disableUpload();
}

function onUnload()
{
//alert('in onUnload '+window.location);
dump('in onUnload '+window.location+' appstart='+gAddressbooksSync.appstarttime+' state='+gAddressbooksSync.state+'\n');
  if (window.location=='chrome://messenger/content/messenger.xul') {
    var windowsEnum = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService()
                     .QueryInterface(Components.interfaces.nsIWindowMediator)
                     .getEnumerator("mail:3pane");
    if (!windowsEnum.hasMoreElements()) { //no more windows, this was the last one! Sync!
dump('onUnload last window closing:'+window.location+"\n");
      removeListener();  // remove the listener
      if (gAddressbooksSync.autoupload) {
dump('onUnload autouploading:'+window.location+"\n");
        var app = Components.classes["@mozilla.org/toolkit/app-startup;1"].
            getService(Components.interfaces.nsIAppStartup);
        app.enterLastWindowClosingSurvivalArea();
        app.createHiddenWindow();
        gAddressbooksSync.exiting=true;
        showPopup('upload', null, gAddressbooksSync.synctype!='local', true, false);  //definitely needs a window for remote/imap!
dump('onUnload popup shown:'+window.location+"\n");
//        showPopup('upload', null, false, true, false);
      }
    }
else dump('onUnload not last:'+window.location+"\n");
  }
}

//Event Listeners
window.addEventListener("load", onLoad, false);
window.addEventListener("unload", onUnload, false);
